# Common files
require 'telecoms_cloud/api_client'
require 'telecoms_cloud/api_error'
require 'telecoms_cloud/version'
require 'telecoms_cloud/configuration'

# Models
require 'telecoms_cloud/models/create_grant_client'
require 'telecoms_cloud/models/locality_info_response_model'
require 'telecoms_cloud/models/sms_outbound_get_status_response_model'
require 'telecoms_cloud/models/sms_outbound_send_response_model'
require 'telecoms_cloud/models/fax_outbound_get_updates_collection_response_model'
require 'telecoms_cloud/models/fax_outbound_get_updates_response_model'
require 'telecoms_cloud/models/fax_outbound_get_status_response_model'
require 'telecoms_cloud/models/fax_outbound_send_response_model'
require 'telecoms_cloud/models/fax_info_collection_response_model'
require 'telecoms_cloud/models/fax_info_model'
require 'telecoms_cloud/models/number_formatter_response_model'
require 'telecoms_cloud/models/account_info_response_model'
require 'telecoms_cloud/models/client_grant_response_model'

# APIs
require 'telecoms_cloud/api/v_api'

module TelecomsCloud
  class << self
    # Customize default settings for the SDK using block.
    #   TelecomsCloud.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
