require 'date'

module TelecomsCloud
  # Model for LocalityInfoResponseModel
  class LocalityInfoResponseModel
    attr_accessor :area_code

    attr_accessor :fibre_date

    attr_accessor :fibre_type

    attr_accessor :ipstream_status

    attr_accessor :isoa2

    attr_accessor :locality_name

    attr_accessor :operator_name

    attr_accessor :partial_number

    attr_accessor :post_code

    attr_accessor :post_town

    attr_accessor :wbc_status

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'area_code' => :'area_code',
        
        :'fibre_date' => :'fibre_date',
        
        :'fibre_type' => :'fibre_type',
        
        :'ipstream_status' => :'ipstream_status',
        
        :'isoa2' => :'isoa2',
        
        :'locality_name' => :'locality_name',
        
        :'operator_name' => :'operator_name',
        
        :'partial_number' => :'partial_number',
        
        :'post_code' => :'post_code',
        
        :'post_town' => :'post_town',
        
        :'wbc_status' => :'wbc_status'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'area_code' => :'String',
        :'fibre_date' => :'String',
        :'fibre_type' => :'String',
        :'ipstream_status' => :'String',
        :'isoa2' => :'String',
        :'locality_name' => :'String',
        :'operator_name' => :'String',
        :'partial_number' => :'String',
        :'post_code' => :'String',
        :'post_town' => :'String',
        :'wbc_status' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'area_code']
        self.area_code = attributes[:'area_code']
      end
      
      if attributes[:'fibre_date']
        self.fibre_date = attributes[:'fibre_date']
      end
      
      if attributes[:'fibre_type']
        self.fibre_type = attributes[:'fibre_type']
      end
      
      if attributes[:'ipstream_status']
        self.ipstream_status = attributes[:'ipstream_status']
      end
      
      if attributes[:'isoa2']
        self.isoa2 = attributes[:'isoa2']
      end
      
      if attributes[:'locality_name']
        self.locality_name = attributes[:'locality_name']
      end
      
      if attributes[:'operator_name']
        self.operator_name = attributes[:'operator_name']
      end
      
      if attributes[:'partial_number']
        self.partial_number = attributes[:'partial_number']
      end
      
      if attributes[:'post_code']
        self.post_code = attributes[:'post_code']
      end
      
      if attributes[:'post_town']
        self.post_town = attributes[:'post_town']
      end
      
      if attributes[:'wbc_status']
        self.wbc_status = attributes[:'wbc_status']
      end
      
    end

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          area_code == o.area_code &&
          fibre_date == o.fibre_date &&
          fibre_type == o.fibre_type &&
          ipstream_status == o.ipstream_status &&
          isoa2 == o.isoa2 &&
          locality_name == o.locality_name &&
          operator_name == o.operator_name &&
          partial_number == o.partial_number &&
          post_code == o.post_code &&
          post_town == o.post_town &&
          wbc_status == o.wbc_status
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [area_code, fibre_date, fibre_type, ipstream_status, isoa2, locality_name, operator_name, partial_number, post_code, post_town, wbc_status].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = TelecomsCloud.const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
