require 'date'

module TelecomsCloud
  # Model for SmsOutboundGetStatusResponseModel
  class SmsOutboundGetStatusResponseModel
    attr_accessor :dispatch_datetime

    attr_accessor :from

    attr_accessor :id

    attr_accessor :receipt_received_datetime

    attr_accessor :receipt_status_code

    attr_accessor :status

    attr_accessor :status_code

    attr_accessor :submit_datetime

    attr_accessor :to

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'dispatch_datetime' => :'dispatch_datetime',
        
        :'from' => :'from',
        
        :'id' => :'id',
        
        :'receipt_received_datetime' => :'receipt_received_datetime',
        
        :'receipt_status_code' => :'receipt_status_code',
        
        :'status' => :'status',
        
        :'status_code' => :'status_code',
        
        :'submit_datetime' => :'submit_datetime',
        
        :'to' => :'to'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'dispatch_datetime' => :'String',
        :'from' => :'String',
        :'id' => :'String',
        :'receipt_received_datetime' => :'String',
        :'receipt_status_code' => :'Integer',
        :'status' => :'String',
        :'status_code' => :'Integer',
        :'submit_datetime' => :'String',
        :'to' => :'String'
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'dispatch_datetime']
        self.dispatch_datetime = attributes[:'dispatch_datetime']
      end
      
      if attributes[:'from']
        self.from = attributes[:'from']
      end
      
      if attributes[:'id']
        self.id = attributes[:'id']
      end
      
      if attributes[:'receipt_received_datetime']
        self.receipt_received_datetime = attributes[:'receipt_received_datetime']
      end
      
      if attributes[:'receipt_status_code']
        self.receipt_status_code = attributes[:'receipt_status_code']
      end
      
      if attributes[:'status']
        self.status = attributes[:'status']
      end
      
      if attributes[:'status_code']
        self.status_code = attributes[:'status_code']
      end
      
      if attributes[:'submit_datetime']
        self.submit_datetime = attributes[:'submit_datetime']
      end
      
      if attributes[:'to']
        self.to = attributes[:'to']
      end
      
    end

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          dispatch_datetime == o.dispatch_datetime &&
          from == o.from &&
          id == o.id &&
          receipt_received_datetime == o.receipt_received_datetime &&
          receipt_status_code == o.receipt_status_code &&
          status == o.status &&
          status_code == o.status_code &&
          submit_datetime == o.submit_datetime &&
          to == o.to
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [dispatch_datetime, from, id, receipt_received_datetime, receipt_status_code, status, status_code, submit_datetime, to].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = TelecomsCloud.const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
